﻿// <auto-generated />
using Hesabdar.Models;
using Hesabdar.Models.Enums;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Metadata;
using Microsoft.EntityFrameworkCore.Migrations;
using Microsoft.EntityFrameworkCore.Storage;
using Microsoft.EntityFrameworkCore.Storage.Internal;
using System;

namespace Hesabdar.Migrations
{
    [DbContext(typeof(HesabdarContext))]
    partial class HesabdarContextModelSnapshot : ModelSnapshot
    {
        protected override void BuildModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("ProductVersion", "2.0.1-rtm-125")
                .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

            modelBuilder.Entity("Hesabdar.Models.Activity", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<byte[]>("Timestamp")
                        .IsConcurrencyToken()
                        .ValueGeneratedOnAddOrUpdate();

                    b.Property<string>("UserName");

                    b.HasKey("Id");

                    b.ToTable("Activity");
                });

            modelBuilder.Entity("Hesabdar.Models.Deal", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<int>("BuyerId");

                    b.Property<int?>("DealPaymentId");

                    b.Property<int?>("DealPriceId");

                    b.Property<DateTime>("DealTime")
                        .ValueGeneratedOnAdd()
                        .HasDefaultValueSql("getdate()");

                    b.Property<int>("SellerId");

                    b.Property<byte[]>("Timestamp")
                        .IsConcurrencyToken()
                        .ValueGeneratedOnAddOrUpdate();

                    b.HasKey("Id");

                    b.HasIndex("BuyerId");

                    b.HasIndex("DealPaymentId");

                    b.HasIndex("DealPriceId");

                    b.HasIndex("SellerId");

                    b.ToTable("Deal");
                });

            modelBuilder.Entity("Hesabdar.Models.Dealer", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<string>("Name");

                    b.Property<byte[]>("Timestamp")
                        .IsConcurrencyToken()
                        .ValueGeneratedOnAddOrUpdate();

                    b.HasKey("Id");

                    b.ToTable("Dealer");
                });

            modelBuilder.Entity("Hesabdar.Models.DealItem", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<int>("DealId");

                    b.Property<int>("MaterialId");

                    b.Property<decimal>("PricePerOne")
                        .HasColumnType("decimal(15, 3)");

                    b.Property<decimal>("Quantity")
                        .HasColumnType("decimal(15, 3)");

                    b.Property<byte[]>("Timestamp")
                        .IsConcurrencyToken()
                        .ValueGeneratedOnAddOrUpdate();

                    b.HasKey("Id");

                    b.HasIndex("DealId");

                    b.HasIndex("MaterialId");

                    b.ToTable("DealItem");
                });

            modelBuilder.Entity("Hesabdar.Models.Material", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<string>("Barcode");

                    b.Property<string>("Name");

                    b.Property<byte[]>("Timestamp")
                        .IsConcurrencyToken()
                        .ValueGeneratedOnAddOrUpdate();

                    b.HasKey("Id");

                    b.ToTable("Material");
                });

            modelBuilder.Entity("Hesabdar.Models.Payment", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<decimal>("Amount")
                        .HasColumnType("decimal(15, 3)");

                    b.Property<DateTime>("DueDate");

                    b.Property<byte>("Method");

                    b.Property<DateTime>("PayDate");

                    b.Property<bool>("Payed");

                    b.Property<int?>("Payee");

                    b.Property<int>("PayeeId");

                    b.Property<int?>("Payer");

                    b.Property<int>("PayerId");

                    b.Property<byte[]>("Timestamp")
                        .IsConcurrencyToken()
                        .ValueGeneratedOnAddOrUpdate();

                    b.HasKey("Id");

                    b.HasIndex("Payee");

                    b.HasIndex("Payer");

                    b.ToTable("Payment");
                });

            modelBuilder.Entity("Hesabdar.Models.Deal", b =>
                {
                    b.HasOne("Hesabdar.Models.Dealer", "Buyer")
                        .WithMany()
                        .HasForeignKey("BuyerId")
                        .OnDelete(DeleteBehavior.Restrict);

                    b.HasOne("Hesabdar.Models.Payment", "DealPayment")
                        .WithMany()
                        .HasForeignKey("DealPaymentId");

                    b.HasOne("Hesabdar.Models.Payment", "DealPrice")
                        .WithMany()
                        .HasForeignKey("DealPriceId");

                    b.HasOne("Hesabdar.Models.Dealer", "Seller")
                        .WithMany()
                        .HasForeignKey("SellerId")
                        .OnDelete(DeleteBehavior.Restrict);
                });

            modelBuilder.Entity("Hesabdar.Models.DealItem", b =>
                {
                    b.HasOne("Hesabdar.Models.Deal", "Deal")
                        .WithMany("Items")
                        .HasForeignKey("DealId")
                        .OnDelete(DeleteBehavior.Restrict);

                    b.HasOne("Hesabdar.Models.Material", "Material")
                        .WithMany()
                        .HasForeignKey("MaterialId")
                        .OnDelete(DeleteBehavior.Restrict);
                });

            modelBuilder.Entity("Hesabdar.Models.Payment", b =>
                {
                    b.HasOne("Hesabdar.Models.Dealer")
                        .WithMany("Incomes")
                        .HasForeignKey("Payee");

                    b.HasOne("Hesabdar.Models.Dealer")
                        .WithMany("Expenses")
                        .HasForeignKey("Payer");
                });
#pragma warning restore 612, 618
        }
    }
}
